<template>
  <div>
    <nav aria-label="breadcrumb">
      <ol class="breadcrumb">  
        <li 
          v-for="(elem, index) in routesList" :key="index" 
          class="breadcrumb-item" 
          :class="{active: isLast(index)}"
        >
          <a href="javascript:void(0)" @click="navigate(elem)" v-if="!isLast(index)">{{ elem.meta.name }}</a>
          <span v-else>{{ elem.meta.name }}</span>
        </li>
      </ol>
    </nav>
  
    <slot></slot>
  </div>
</template>

<script setup lang="ts">
import { inject, computed, ref, type Ref, provide, type InjectionKey } from 'vue'
import type { Router, RouteRecordNormalized } from "vue-router";
import { BreadCrumbElement, type BreadCrumbRoute, BreadCrumbKey } from "./breadcrumb";

const router = inject<Router>('routerBreadcrumb');
const routerRoutes = computed<RouteRecordNormalized[] | undefined>(() =>{
  return router?.getRoutes();
});
const breadCrumbElement: Ref<BreadCrumbElement> = ref(new BreadCrumbElement());
const routesList = computed(() => {
  return generateRoutes(breadCrumbElement.value.getRoutes());
});

//#region FUNCIONES
function navigate(route: RouteRecordNormalized){
  router!.push(route);
}
function findRouteByName(name: string): RouteRecordNormalized | undefined {
  if(routerRoutes.value !== undefined){
    return routerRoutes.value?.find((route: RouteRecordNormalized) => {
      return route.name == name;
    })
  }
  return undefined;
}
function generateRoutes(newRoutes: BreadCrumbRoute[]): RouteRecordNormalized[]{
  let newList: RouteRecordNormalized[] = [];
  newRoutes.forEach((route: BreadCrumbRoute) => {
    if(route.name !== undefined){
      let name: string = route.name.toString();
      let search = findRouteByName(name);
      if(search !== undefined){;
        newList.push(Object.assign(route, search));
      }
    }
  });
  return newList;
}
function updateRoutes(newRoutes: BreadCrumbRoute[]) {
  breadCrumbElement.value.initRoutes(newRoutes);
}
function isLast(index: number){
  return (index + 1 == routesList.value.length)
}
//#endregion

provide(BreadCrumbKey, breadCrumbElement);

defineExpose({
  updateRoutes
});

</script>

<style scoped>
.breadcrumb-item{
	font-size: 13px!important;
	font-weight: 700!important;
	
}
.breadcrumb-item a{
	color:#178293!important;
	text-decoration: none!important;;
	border: 0px!important;;
	font-weight: 500!important;
}
.breadcrumb-item a:hover{
	color:#202020!important;
}

</style>